
/*
	Created V1: 22/11/2018 - 15:xx
*/

//Add CreateSupport method to global app object. 
app.CreateSupport = function() { try{ return new Support(); } catch(e){ app._93(e,"Support Error!"); }; };

//Plugin wrapper class.
function Support( options )
{
	var dw = app._132();
	var dh = app._133();
    	this.plg = _CreatePlugin( "com.candlelight.support.plugins.user.Support", options );
    
	this.GetVersion = function() { return parseFloat( this.plg.Send( "GetVersion" ) ); };
	this.SetRipple = function( obj, over, radius, color ) { return this.plg.SendObj( "SetRipple", obj, over, radius, color ); };
	this.On = function( en, obj, cb ) { this.plg.SendObj( "AddEventListener", obj, en, cb.name ); };
	this.EnableDrag = function( obj, tag, os ) { this.plg.SendObj( "AddEventListener", obj, "SetDraggable", tag+"", (os?os.name:"") ); };
	this.PlayAnim = function( obj, name ) { this.plg.SendObj( "Anim", obj, name ); };
	this.AnimationManager = function() { return new AnimationManager(this.plg); };
	this.SetState = function( obj, clr1, clr2, radius ) { return this.plg.SendObj( "SetStyle", obj, clr1, clr2, radius ); };
	this.SetFastScroll = function( obj, bool ) { return this.plg.SendObj( "FastScroll", obj, bool ); };
	this.SetMinSize = function( obj, w, h ) { p.SendObj( "MinSize", obj, (w?dw*w:-1), (h?dh*h:-1) ); };
	this.Alert = function( text, title, btntxt, opt ) { return this.plg.Send( "ShowAlert", text, title||"", (opt?opt.toLowerCase()+",alert":"alert"), btntxt ); };
	this.SetAdapter = function( obj, list, cb ) { for( i=0; i<list.length; i++ ) { var view = cb(list[i],i); this.plg.SendObj( "Views", view ); }; return this.plg.SendObj( "SetAdapter", obj ); }
	
	NewMethods( this.plg );
	
	/* Text Edit */
	this.CreateTextEdit = function( text, width, height, opt ) {
	var ret = this.plg.CreateObj( "CreateTextEdit", text.toString()||"", (width?width*dw:-1), (height?height*dh:-1), (opt||"").toLowerCase() );
	if( ret ) return new CreateTextEdit(ret,this.plg); else return null;
	}
	
	/* Circle Image */
	this.CreateCircleImage = function( src, radius ) {
	this.plg.SendObj( "Child", app._254(src) );
	var ret = this.plg.CreateObj( "CreateCircleImage", radius?radius*dw:-1 );
	if( ret ) return new CreateCircleImage(ret,this.plg); else return null;
	};
	
	/* Page Viewer */
	this.CreatePageViewer = function( opt ) {
	var ret = this.plg.CreateObj( "CreatePageViewer", (opt||"").toLowerCase() );
	if( ret ) return new CreatePageViewer(ret,this.plg); else return null;
	};
	
	/* Dialog. */
	this.CreateDialog = function( width, height, opt ) {
	var ret = this.plg.CreateObj( "CreateCustomDialog", width||-1, height||-1, (opt||"").toLowerCase() );
	if( ret ) return new CreateCustomDialog(ret,this.plg); else return null;
	};
	
	/* Bottom Sheet. */
	this.CreateBottomSheet = function( width, height, opt ) {
	var ret = this.plg.CreateObj( "CreateCustomBottomSheet", width||-1, height||-1, (opt||"").toLowerCase() );
	if( ret ) return new CreateCustomBottomSheet(ret,this.plg); else return null;
	};
	
	/* Yes No Dialog. */
	this.CreateYesNoDialog = function( text, title, opt ) { 
	var ret = this.plg.CreateObj( "CreateYesNoDialog", text||"", title||"", (opt||"").toLowerCase() );
	if( ret ) return new CreateYesNoDialog(ret,this.plg); else return null;
	};
	
	this.CreateListDialog = function( list, title, opt ) {
	var ret = this.plg.CreateObj( "CreateListDialog", list||"", title||"", (opt||"").toLowerCase() );
	if( ret ) return new CreateListDialog(ret,this.plg); else return null;
	};
	
	this.CreateBottomSheetList = function( list, title, opt ) {
	var ret = this.plg.CreateObj( "CreateBottomSheetList", list||"", title||"", (opt||"").toLowerCase() );
	if( ret ) return new CreateBottomSheetList(ret,this.plg); else return null;
	};
	
	/* Ripple Layout */
	this.CreateRippleLayout = function( opt ) { 
        var ret = this.plg.CreateObj( "CreateRippleLayout", (opt||"").toLowerCase() );  
        if( ret ) return new CreateRippleLayout(ret,this.plg); else return null; 
    	};
	
	/* Swipe Refresh Layout */
	this.CreateSwipeRefreshLayout = function( opt ) { 
        var ret = this.plg.CreateObj( "CreateSwipeRefreshLayout", (opt||"").toLowerCase() );  
        if( ret ) return new CreateSwipeRefreshLayout(ret,this.plg); else return null; 
    	};
    	
    	/* Grid Layout */
	this.CreateGridLayout = function( opt ) { 
        var ret = this.plg.CreateObj( "CreateGridLayout", (opt||"").toLowerCase() );  
        if( ret ) return new CreateGridLayout(ret,this.plg); else return null; 
    	};
    	
    	/* Progress */
    	this.CreateProgress = function( radius ) {
    	var ret = this.plg.CreateObj( "CreateProgress", (radius?radius*dw:-1) );
    	if( ret ) return new CreateProgress(ret,this.plg); else return null;
    	};
    	
    	/* Popup Menu */
    	this.CreatePopupMenu = function( view ) {
    	this.plg.SendObj( "Child", view );
    	var ret = this.plg.CreateObj( "CreatePopupMenu" );
    	if( ret ) return new CreatePopupMenu(ret,this.plg); else return null;
    	};
    	
}

function NewMethods(p)
{
	Obj.prototype.On = function( en, cb ) { p.SendObj( "AddEventListener", this, en, cb.name ); };
	Obj.prototype.EnableDrag = function( tagname, os ) { p.SendObj( "AddEventListener", this, "SetDraggable", tagname||"Drag_Item", (os?os.name:"") ); };
	Obj.prototype.PlayAnim = function( name ) { p.SendObj( "Anim", this, name ); };
	Obj.prototype.SetState = function( clr1, clr2, radius ) { p.SendObj( "SetStyle", this, clr1, clr2, radius ); };
	Obj.prototype.SetRipple = function( over, radius, color ) { p.SendObj( "SetRipple", this, over, radius, color ); };
	Obj.prototype.SetTag = function( tag ) { this.tag = tag; return p.SendObj( "SetTag", this, tag+"" ); };
	Obj.prototype.SetAlpha = function( val ) { p.SendObj( "SetAlpha", this, val ); };
	Obj.prototype.SetFastScroll = function( bool ) { p.SendObj( "FastScroll", this, bool ); };
	Obj.prototype.SetMinSize = function( w, h ) { p.SendObj( "MinSize", this, (w?app._132()*w:-1), (h?app._133()*h:-1) ); };
	// Obj.prototype.SetAdapter = function( list, cb ) { for( i=0; i<list.length; i++ ) { var view = cb(list[i],i); p.SendObj( "Views", view ); }; return p.SendObj( "SetAdapter", this ); }
}

function CreateTextEdit( id, p )
{
	var obj = new Obj(id);
	var n = "EDT:";
	obj.GetType = function() { return "TextEdit"; };
	obj.SetText = function( txt ) { return p.SendObj( n+"Text", obj, txt ); };
	obj.GetText = function() { return p.SendObj( n+"GetText", obj ); };
	obj.SetTextSize = function( size ) { return p.SendObj( n+"TextSize", obj, size ); };
	obj.SetTextColor = function( color ) { return p.SendObj( n+"TextColor", obj, color ); };
	obj.SetHint = function( txt ) { return p.SendObj( n+"Hint", obj, txt ); };
	obj.SetError = function( txt ) { return p.SendObj( n+"Error", obj, txt ); };
	obj.SetErrorColor = function( color ) { return p.SendObj( n+"ErrorColor", obj, color ); };
	obj.SetMaxSize = function( size ) { return p.SendObj( n+"MaxSize", obj, size ); };
	obj.SetColor = function( color ) { return p.SendObj( n+"Color", obj, color ); };
	obj.SetOnChange = function( cb ) { return p.SendObj( "ED:On", obj, cb.name ); };
	return obj;
}

function CreateCircleImage( id, p )
{
	var obj = new Obj(id);
	var n = "CIV:";
	obj.GetType = function() { return "CircleImage"; };
	obj.SetBorderWidth = function( size ) { return p.SendObj( n+"BorderWidth", obj, size ); };
	obj.SetBorderColor = function( color ) { return p.SendObj( n+"BorderColor", obj, color ); };
	obj.SetBorderOverlay = function( bool ) { return p.SendObj( n+"BorderOverlay", obj, bool ); };
	obj.SetCircleBackColor = function( color ) { return p.SendObj( n+"CircleBackColor", obj, color ); };
	obj.SetImage = function( src ) { p.SendObj( "Child", app._254(src) ); return p.SendObj( "SetImage", obj ); };
	return obj;
}

function CreatePageViewer( id, p )
{
	var obj = new Obj(id);
	var n = "PVR:";
	obj.GetType = function() { return "PageViewer"; };
	obj.AddPages = function() { for( var i in arguments ) p.SendObj( "Childs", arguments[i] ); return p.SendObj( "SetPages", obj ); };
	obj.AddPages2 = function( arr ) { for( var i in arr ) p.SendObj( "Childs", arr[i] ); return p.SendObj( "SetPages", obj ); };
	obj.Ready = function() { return p.SendObj( "SetPages", obj ); };
	obj.SetCurrentPage = function( index ) { return p.SendObj( "SetCurrentPage", obj, index ); };
	obj.GetCurrentPage = function() { return p.SendObj( "GetCurrentPage", obj ); };
	obj.SetOnChange = function( cb ) { return p.SendObj( "OnPageChange", obj, cb.name ); };
	obj.PreviousPage = function() { var cur = p.SendObj( "GetCurrentPage", obj ); cur = Number(cur)-1; p.SendObj( "SetCurrentPage", obj, cur ); return cur; };
	obj.NextPage = function() { var cur = p.SendObj( "GetCurrentPage", obj ); cur = Number(cur)+1; p.SendObj( "SetCurrentPage", obj, cur ); return cur; };
	return obj;
}

/*
	Dialog
*/

function DlgObj(obj,p)
{
	obj.ShowAnim = function( anim ) { return p.SendObj( "DLG:ShowAnim", obj, anim.name ); };
	obj.DismissAnim = function( anim ) { return p.SendObj( "DLG:DismissAnim", obj, anim.name ); };
	obj.SetSize = function( w, h ) { return p.SendObj( "DLG:SetSize", obj, w, h ); };
	obj.SetOnTouch = function( cb ) { return p.SendObj( "DG:On", obj, cb.name ); };
	obj.Show = function() { return p.SendObj( "DLG:Show", obj ); };
	obj.Dismiss = function() { return p.SendObj( "DLG:Dismiss", obj ); };
}

function CreateCustomDialog( id, p )
{
	var obj = new Obj(id);
	var n = "CUD:";
	obj.GetType = function() { return "Dialog"; };
	obj.AddChild = function( view ) { p.SendObj( "Child", view ); return p.SendObj( n+"AddChild", obj ); };
	DlgObj( obj, p );
	return obj;
}

function CreateCustomBottomSheet( id, p )
{
	var obj = new Obj(id);
	var n = "CBS:";
	obj.GetType = function() { return "BottomSheet"; };
	obj.AddChild = function( view ) { p.SendObj( "Child", view ); return p.SendObj( n+"AddChild", obj ); };
	DlgObj( obj, p );
	return obj;
}

function CreateListDialog( id, p )
{
	var obj = new Obj(id);
	var n = "CLD:";
	obj.GetType = function() { return "ListDialog"; };
	obj.SetCornerRadius = function( val ) { return p.SendObj( n+"SetCornerRadius", obj, val ); };
	obj.SetDividerColor = function( clr ) { return p.SendObj( n+"SetDividerColor", obj, clr ); };
	obj.SetDividerHeight = function( h ) { return p.SendObj( n+"SetDividerHeight", obj, app._133()*h ); };
	obj.SetItemPressColor = function( clr ) { return p.SendObj( n+"SetItemPressColor", obj, clr ); };
	obj.SetItemTextColor = function( clr ) { return p.SendObj( n+"SetItemTextColor", obj, clr ); };
	obj.SetItemTextSize = function( size ) { return p.SendObj( n+"SetItemTextSize", obj, app._133()*size ); };
	obj.SetTitleTextColor = function( clr ) { return p.SendObj( n+"SetTitleTextColor", obj, clr ); };
	obj.SetTitleTextSize = function( size ) { return p.SendObj( n+"SetTitleTextSize", obj, size ); };
	obj.SetTitleBackColor = function( clr ) { return p.SendObj( n+"SetTitleBackColor", obj, clr ); };
	DlgObj( obj, p );
	return obj;
}

function CreateYesNoDialog( id, p )
{
	var obj = new Obj(id);
	var n = "YND:";
	obj.GetType = function() { return "YesNoDialog"; };
	obj.SetButtonText = function( left, mid, right ) { return p.SendObj( n+"SetButtonText", obj, left, mid, right ); };
	obj.SetTitleSize = function( size ) { return p.SendObj( n+"SetTitleSize", app._132()*size ); };
	obj.SetTitleColor = function( clr ) { return p.SendObj( n+"SetTitleColor", obj, clr ); };
	obj.SetTextSize = function( size ) { return p.SendObj( n+"SetTextSize", obj, app._132()*size ); };
	obj.SetTextColor = function( clr ) { return p.SendObj( n+"SetTextColor", obj, clr ); };
	obj.SetCornerRadius = function( rad ) { return p.SendObj( n+"SetRadius", obj, rad ); };
	DlgObj( obj, p );
	return obj;
}

function CreateBottomSheetList( id, p )
{
	var obj = new Obj(id);
	var n = "BSL:";
	obj.GetType = function() { return "BottomSheetList"; };
	obj.SetCornerRadius = function( val ) { return p.SendObj( n+"SetCornerRadius", obj, val ); };
	obj.SetDividerColor = function( clr ) { return p.SendObj( n+"SetDividerColor", obj, clr ); };
	obj.SetDividerHeight = function( h ) { return p.SendObj( n+"SetDividerHeight", obj, app._133()*h ); };
	obj.SetItemPressColor = function( clr ) { return p.SendObj( n+"SetItemPressColor", obj, clr ); };
	obj.SetItemTextColor = function( clr ) { return p.SendObj( n+"SetItemTextColor", obj, clr ); };
	obj.SetItemTextSize = function( size ) { return p.SendObj( n+"SetItemTextSize", obj, app._133()*size ); };
	obj.SetTitleTextColor = function( clr ) { return p.SendObj( n+"SetTitleTextColor", obj, clr ); };
	obj.SetTitleTextSize = function( size ) { return p.SendObj( n+"SetTitleTextSize", obj, size ); };
	obj.SetTitleBackColor = function( clr ) { return p.SendObj( n+"SetTitleBackColor", obj, clr ); };
	obj.SetButtonText = function( txt ) { return p.SendObj( n+"SetButtonText", obj, txt ); };
	obj.SetButtonTextColor = function( txt ) { return p.SendObj( n+"SetButtonTextColor", obj, clr ); };
	obj.SetButtonTextSize = function( size ) { return p.SendObj( n+"SetButtonText", obj, app._132()*size ); };
	DlgObj( obj, p );
	return obj;
}

/*
	Widgets
*/

function CreatePopupMenu( id, p )
{
	var obj = new Obj(id);
	obj.SetList = function( list ) { return p.SendObj( "SetPopupList", obj, list ); };
	obj.SetOnTouch = function( cb ) { return p.SendObj( "PopupOnTouch", obj, cb.name ); };
	obj.Show = function() { return p.SendObj( "PopupShow", obj ); };
	obj.Dismiss = function() { return p.SendObj( "PopupDismiss", obj ); };
	return obj;
}

function CreateProgress( id, p )
{
	var obj = new Obj(id);
	var n = "PRG:";
	obj.GetType = function() { return "Progress"; };
	obj.SetLinearProgress = function( bool ) { return p.SendObj( n+"SetLinearProgress", obj, bool ); };
	obj.SetSpinSpeed = function( val ) { return p.SendObj( n+"SetSpinSpeed", obj, val ); };
	obj.SetInstantProgress = function( val ) { return p.SendObj( n+"SetInstantProgress", obj, val ); };
	obj.SetProgress = function( val ) { return p.SendObj( n+"SetProgress", obj, val ); };
	obj.SetBarWidth = function( width ) { return p.SendObj( n+"SetBarWidth", obj, width ); };
	obj.SetCircleRadius = function( rad ) { return p.SendObj( n+"SetCircleRadius", obj, app._132()*rad ); };
	obj.SetBarColor = function( clr ) { return p.SendObj( n+"SetBarColor", obj, clr ); };
	obj.SetRimColor = function( clr ) { return p.SendObj( n+"SetRimColor", obj, clr ); };
	obj.SetRimWidth = function( width ) { return p.SendObj( n+"SetRimWidth", obj, width ); };
	obj.SetSpin = function( bool ) { return p.SendObj( n+"SetSpin", obj, bool ); };
	obj.IsSpining = function() { return p.SendObj( n+"IsSpining", obj ) == "true"; };
	return obj;
}

/*
	Layouts.
*/

function CreateRippleLayout( id, p )
{
	var obj = new Obj(id);
	var n = "RPL:";
	obj.GetType = function() { return "RippleLayout"; };
	obj.SetRippleAlpha = function( alpha ) { return p.SendObj( n+"SetRippleAlpha", obj, alpha ); };
	obj.SetRippleColor = function( clr ) { return p.SendObj( n+"SetRippleColor", obj, clr ); };
	obj.SetRippleOverlay = function( bool ) { return p.SendObj( n+"SetRippleOverlay", obj, bool ); };
	obj.SetRippleRadius = function( val ) { return p.SendObj( n+"SetRippleRadius", obj, val ); };
	obj.SetRippleBackColor = function( color ) { return p.SendObj( n+"SetRippleBackColor", obj, color ); };
	obj.SetRadius = function( val ) { return p.SendObj( n+"SetRadius", obj, val ); };
	obj.AddChild = function( child ) { p.SendObj( "Child", child ); return p.SendObj( "AddChild", obj, "Ripple" ); };
	return obj;
}

function CreateSwipeRefreshLayout( id, p )
{
	var obj = new Obj(id);
	var n = "SRL:";
	obj.GetType = function() { return "SwipeRefreshLayout"; };
	obj.SetOnRefresh = function( cb ) { return p.SendObj( "OnRefreshListener", obj, cb.name ); };
	obj.SetRefreshing = function( bool ) { return p.SendObj( n+"SetRefreshing", obj, bool ); };
	obj.SetColors = function( clr1,clr2,clr3,clr4 ) { return p.SendObj( n+"SetColors", obj, clr1, clr2, clr3, clr4 ); };
	obj.SetBackColor = function( clr ) { return p.SendObj( n+"ProgressBackColor", obj, clr ); };
	obj.AddChild = function( child ) { p.SendObj( "Child", child ); return p.SendObj( "AddChild", obj, "Swipe" ); };
	return obj;
}

function CreateGridLayout( id, p )
{
	var obj = new Obj(id);
	var n = "GRL:";
	obj.GetType = function() { return "GridLayout"; };
	obj.SetColCount = function( cnt ) { return p.SendObj( n+"ColumnCount", obj, cnt ); };
	obj.SetRowCount = function( cnt ) { return p.SendObj( n+"RowCount", obj, cnt ); };
	obj.SetAlignMode = function( mode ) { return p.SendObj( n+"AlignMode", obj, mode.toLowerCase() ); };
	obj.AddChild = function( child ) { p.SendObj( "Child", child ); return p.SendObj( "AddChild", obj, "Grid" ); };
	return obj;
}

/*
	Helpers
*/

function AnimationManager( p )
{
	this.name,this.obj;
	//New.
	this.NewsPaper = function( o ) { this.name = "NewsPaper"; this.obj = o; return this; };
	this.Jelly = function( o ) { this.name = "Jelly"; this.obj = o; return this; };
	
	//Attenatiaon.
	this.Flash = function( o ) { this.name = "Flash"; this.obj = o; return this; };
	this.RubberBand = function( o ) { this.name = "RubberBand"; this.obj = o; return this; };
	this.ShakeHorizontal = function( o ) { this.name = "ShakeHorizontal"; this.obj = o; return this; };
	this.ShakeVertical = function( o ) { this.name = "ShakeVertical"; this.obj = o; return this; };
	this.Swing = function( o ) { this.name = "Swing"; this.obj = o; return this; };
	this.TaDa = function( o ) { this.name = "TaDa"; this.obj = o; return this; };
	
	// Bounce.
	this.Bounce = function( o ) { this.name = "Bounce"; this.obj = o; return this; };
	this.BounceLeft = function( o ) { this.name = "BounceLeft"; this.obj = o; return this; };
	this.BounceTop = function( o ) { this.name = "BounceTop"; this.obj = o; return this; };
	this.BounceRight = function( o ) { this.name = "BounceRight"; this.obj = o; return this; };
	this.BounceBottom = function( o ) { this.name = "BounceBottom"; this.obj = o; return this; };
	
	// Fade.
	this.FadeIn = function( o ) { this.name = "Fadein"; this.obj = o; return this; };
	this.FadeOut = function( o ) { this.name = "FadeOut"; this.obj = o; return this; };
	
	// Fall.
	this.Fall = function( o ) { this.name = "Fall"; this.obj = o; return this; };
	this.FallRotate = function( o ) { this.name = "FallRotate"; this.obj = o; return this; };
	
	// Flip.
	this.FlipFromVerticalSwing = function( o ) { this.name = "FlipFromVerticalSwing"; this.obj = o; return this; };
	this.FlipFromHorizontal = function( o ) { this.name = "FlipFromHorizontal"; this.obj = o; return this; };
	this.FlipFromBottom = function( o ) { this.name = "FlipFromBottom"; this.obj = o; return this; };
	this.FlipFromVertical = function( o ) { this.name = "FlipFromVertical"; this.obj = o; return this; };
	this.FlipFromHorizontalSwing = function( o ) { this.name = "FlipFromHorizontalSwing"; this.obj = o; return this; };
	this.FlipFromTop = function( o ) { this.name = "FlipFromTop"; this.obj = o; return this; };
	this.FlipFromRight = function( o ) { this.name = "FlipFromRight"; this.obj = o; return this; };
	this.FlipFromLeft = function( o ) { this.name = "FlipFromLeft"; this.obj = o; return this; };
	this.FlipToHorizontal = function( o ) { this.name = "FlipToHorizontal"; this.obj = o; return this; };
	this.FlipToVertical = function( o ) { this.name = "FlipToVertical"; this.obj = o; return this; };
	
	// Slide.
	this.SlideFromLeft = function( o ) { this.name = "SlideFromLeft"; this.obj = o; return this; };
	this.SlideFromTop = function( o ) { this.name = "SlideFromTop"; this.obj = o; return this; };
	this.SlideFromRight = function( o ) { this.name = "SlideFromRight"; this.obj = o; return this; };
	this.SlideFromBottom = function( o ) { this.name = "SlideFromBottom"; this.obj = o; return this; };
	this.SlideToLeft = function( o ) { this.name = "SlideToLeft"; this.obj = o; return this; };
	this.SlideToTop = function( o ) { this.name = "SlideToTop"; this.obj = o; return this; };
	this.SlideToRight = function( o ) { this.name = "SlideToRight"; this.obj = o; return this; };
	this.SlideToBottom = function( o ) { this.name = "SlideToBottom"; this.obj = o; return this; };
	
	// Zoom.
	this.ZoomInEnter = function( o ) { this.name = "ZoominEnter"; this.obj = o; return this; };
	this.ZoomInExit = function( o ) { this.name = "ZoominExit"; this.obj = o; return this; };
	this.ZoomInLeft = function( o ) { this.name = "ZoominLeft"; this.obj = o; return this; };
	this.ZoomInTop = function( o ) { this.name = "ZoominTop"; this.obj = o; return this; };
	this.ZoomInRight = function( o ) { this.name = "ZoominRight"; this.obj = o; return this; };
	this.ZoomInBottom = function( o ) { this.name = "ZoominBottom"; this.obj = o; return this; };
	this.ZoomOutExit = function( o ) { this.name = "ZoomOutExit"; this.obj = o; return this; };
	this.ZoomOutLeft = function( o ) { this.name = "ZoomOutLeft"; this.obj = o; return this; };
	this.ZoomOutTop = function( o ) { this.name = "ZoomOutTop"; this.obj = o; return this; };
	this.ZoomOutRight = function( o ) { this.name = "ZoomOutRight"; this.obj = o; return this; };
	this.ZoomOutBottom = function( o ) { this.name = "ZoomOutBottom"; this.obj = o; return this; };
	
	// Run.
	this.Play = function( ob ) { var co = (ob||this.obj); p.SendObj( "Anim", co, this.name ); };
	this.SetOnEnd = function() {};
	this.Toggle = function() {};
	
	// Other.
	this.keys = ["NewsPaper","Jelly",
	"Flash","RubberBand","ShakeHorizontal","ShakeVertical","Swing","TaDa",
	"Bounce","BounceLeft","BounceTop","BounceRight","BounceBottom",
	"Fadein","FadeOut",
	"Fall","FallRotate",
	"FlipFromVerticalSwing","FlipFromHorizontal","FlipFromBottom","FlipFromVertical","FlipFromHorizontalSwing","FlipFromTop","FlipFromRight","FlipFromLeft","FlipToHorizontal","FlipToVertical",
	"SlideFromLeft","SlideFromTop","SlideFromRight","SlideFromBottom","SlideToLeft","SlideToTop","SlideToRight","SlideToBottom",
	"ZoominEnter","ZoominExit","ZoominLeft","ZoominTop","ZoominRight","ZoominBottom",
	"ZoomOutExit","ZoomOutLeft","ZoomOutTop","ZoomOutRight","ZoomOutBottom"
	];
}

/*
	Color
*/

var _or = function ( land, port ) { return ( app._135() == "Landscape" ) ? land : port; }
var _asp = app._132() / app._133();

// Read all color.
var color = {
 "keys": [ "RED", "PINK", "PURPLE", "DEEP_PURPLE", "INDIGO", "BLUE", "LIGHT_BLUE", "CYAN", "TEAL", "GREEN", "LIGHT_GREEN", "LIME", "YELLOW", "AMBER", "ORANGE", "DEEP_ORANGE", "BROWN", "GREY", "BLUE_GREY", "BLACK", "WHITE", "TRANS" ],
 "mask": [ "LIGHT_1", "LIGHT_2", "LIGHT_3", "LIGHT_4", "LIGHT_5", "DARK_1", "DARK_2", "DARK_3", "DARK_4", "ACCENT_1", "ACCENT_2", "ACCENT_3", "ACCENT_4" ],
 "mask_white": [ "DARK_1", "DARK_2", "DARK_3", "DARK_4" ],
 "mask_black": [ "LIGHT_1", "LIGHT_2", "LIGHT_3", "LIGHT_4", "LIGHT_5", "ACCENT_1", "ACCENT_2", "ACCENT_3", "ACCENT_4" ],
 "LIGHT_GREEN_ACCENT_4": "#64dd17",
 "TEAL_ACCENT_4": "#00bfa5",
 "TEAL_ACCENT_3": "#1de9b6",
 "TEAL_ACCENT_2": "#64ffda",
 "TEAL_ACCENT_1": "#a7ffeb",
 "LIGHT_GREEN_ACCENT_3": "#76ff03",
 "GREY_LIGHT_2": "#e0e0e0",
 "DEEP_ORANGE_DARK_4": "#bf360c",
 "INDIGO_LIGHT_5": "#e8eaf6",
 "INDIGO_LIGHT_4": "#c5cae9",
 "INDIGO_LIGHT_3": "#9fa8da",
 "INDIGO_LIGHT_2": "#7986cb",
 "INDIGO_LIGHT_1": "#5c6bc0",
 "GREY_LIGHT_5": "#fafafa",
 "BLUE_GREY_LIGHT_4": "#cfd8dc",
 "BLUE_GREY_LIGHT_5": "#eceff1",
 "BLUE_GREY_LIGHT_2": "#90a4ae",
 "BLUE_GREY_LIGHT_3": "#b0bec5",
 "DEEP_ORANGE_LIGHT_2": "#ff8a65",
 "DEEP_ORANGE_LIGHT_1": "#ff7043",
 "LIGHT_GREEN_ACCENT_1": "#ccff90",
 "TEAL_DARK_4": "#004d40",
 "DEEP_ORANGE_DARK_2": "#e64a19",
 "TEAL_DARK_1": "#00897b",
 "TEAL_DARK_2": "#00796b",
 "TEAL_DARK_3": "#00695c",
 "RED_LIGHT_5": "#FFEBEE",
 "RED_LIGHT_4": "#FFCDD2",
 "CYAN_LIGHT_4": "#b2ebf2",
 "CYAN_LIGHT_5": "#e0f7fa",
 "RED_LIGHT_1": "#EF5350",
 "CYAN_LIGHT_3": "#80deea",
 "RED_LIGHT_3": "#EF9A9A",
 "RED_LIGHT_2": "#E57373",
 "INDIGO_ACCENT_4": "#304ffe",
 "CYAN_ACCENT_4": "#00b8d4",
 "RED_ACCENT_4": "#D50000",
 "RED_ACCENT_3": "#FF1744",
 "RED_ACCENT_2": "#FF5252",
 "INDIGO_ACCENT_3": "#3d5afe",
 "INDIGO_ACCENT_2": "#536dfe",
 "DEEP_ORANGE_LIGHT_4": "#ffccbc",
 "BLUE_DARK_4": "#0D47A1",
 "GREY_LIGHT_1": "#bdbdbd",
 "BLUE_DARK_2": "#1976D2",
 "BLUE_DARK_3": "#1565C0",
 "BLUE_DARK_1": "#1E88E5",
 "GREY_DARK_1": "#757575",
 "GREY_DARK_3": "#424242",
 "BLUE_GREY_DARK_2": "#455a64",
 "GREY_DARK_4": "#212121",
 "LIGHT_GREEN_DARK_3": "#558b2f",
 "LIGHT_GREEN_DARK_2": "#689f38",
 "LIGHT_GREEN_DARK_1": "#7cb342",
 "GREY_LIGHT_4": "#f5f5f5",
 "LIGHT_GREEN_DARK_4": "#33691e",
 "PURPLE_ACCENT_1": "#ea80fc",
 "PURPLE_ACCENT_3": "#d500f9",
 "PURPLE_ACCENT_2": "#e040fb",
 "PURPLE_ACCENT_4": "#aa00ff",
 "RED_DARK_4": "#B71C1C",
 "LIGHT_BLUE": "#03a9f4",
 "LIME_DARK_1": "#c0ca33",
 "GREEN_DARK_1": "#43A047",
 "CYAN_DARK_1": "#00acc1",
 "RED_DARK_1": "#E53935",
 "RED_DARK_2": "#D32F2F",
 "RED_DARK_3": "#C62828",
 "ORANGE_DARK_2": "#f57c00",
 "CYAN_LIGHT_1": "#26c6da",
 "PINK_LIGHT_5": "#fce4ec",
 "PINK_LIGHT_4": "#f8bbd0",
 "PINK_LIGHT_3": "#f48fb1",
 "PINK_LIGHT_2": "#f06292",
 "PINK_LIGHT_1": "#ec407a",
 "TEAL_LIGHT_3": "#80cbc4",
 "BROWN_DARK_4": "#3e2723",
 "INDIGO": "#3f51b5",
 "BROWN_DARK_3": "#4e342e",
 "BROWN_DARK_2": "#5d4037",
 "PINK_ACCENT_1": "#ff80ab",
 "LIGHT_BLUE_DARK_4": "#01579b",
 "PINK_ACCENT_3": "#f50057",
 "PINK_ACCENT_2": "#ff4081",
 "LIGHT_BLUE_DARK_1": "#039be5",
 "PINK_ACCENT_4": "#c51162",
 "LIGHT_BLUE_DARK_3": "#0277bd",
 "LIGHT_BLUE_DARK_2": "#0288d1",
 "DEEP_ORANGE": "#ff5722",
 "INDIGO_DARK_4": "#1a237e",
 "INDIGO_DARK_2": "#303f9f",
 "INDIGO_DARK_3": "#283593",
 "INDIGO_DARK_1": "#3949ab",
 "TEAL_LIGHT_5": "#e0f2f1",
 "TEAL_LIGHT_4": "#b2dfdb",
 "DEEP_PURPLE": "#673ab7",
 "GREEN_DARK_2": "#388E3C",
 "BROWN_DARK_1": "#6d4c41",
 "CYAN_DARK_4": "#006064",
 "DEEP_PURPLE_LIGHT_3": "#b39ddb",
 "DEEP_PURPLE_LIGHT_2": "#9575cd",
 "DEEP_PURPLE_LIGHT_1": "#7e57c2",
 "BLUE_GREY_DARK_1": "#546e7a",
 "LIGHT_BLUE_ACCENT_4": "#0091ea",
 "DEEP_PURPLE_LIGHT_5": "#ede7f6",
 "DEEP_PURPLE_LIGHT_4": "#d1c4e9",
 "YELLOW_LIGHT_5": "#fffde7",
 "YELLOW_LIGHT_4": "#fff9c4",
 "YELLOW_LIGHT_1": "#ffee58",
 "TRANS": "#00ffffff",
 "YELLOW_LIGHT_3": "#fff59d",
 "YELLOW_LIGHT_2": "#fff176",
 "GREEN_ACCENT_1": "#B9F6CA",
 "CYAN_DARK_3": "#00838f",
 "BROWN": "#795548",
 "CYAN_DARK_2": "#0097a7",
 "GREEN_ACCENT_3": "#00E676",
 "CYAN_ACCENT_2": "#18ffff",
 "YELLOW_DARK_1": "#fdd835",
 "YELLOW_DARK_2": "#fbc02d",
 "YELLOW_DARK_3": "#f9a825",
 "YELLOW_DARK_4": "#f57f17",
 "ORANGE_DARK_3": "#ef6c00",
 "LIME": "#cddc39",
 "ORANGE_DARK_1": "#fb8c00",
 "BLUE_GREY_DARK_4": "#263238",
 "ORANGE_LIGHT_2": "#ffb74d",
 "GREY_LIGHT_3": "#eeeeee",
 "ORANGE_DARK_4": "#e65100",
 "AMBER_DARK_4": "#ff6f00",
 "AMBER_DARK_2": "#ffa000",
 "AMBER_DARK_3": "#ff8f00",
 "AMBER_DARK_1": "#ffb300",
 "BLUE_ACCENT_1": "#82B1FF",
 "CYAN_LIGHT_2": "#4dd0e1",
 "BLUE_ACCENT_3": "#2979FF",
 "BLUE_ACCENT_2": "#448AFF",
 "BLUE_ACCENT_4": "#2962FF",
 "GREY": "#9e9e9e",
 "LIGHT_BLUE_ACCENT_2": "#40c4ff",
 "LIGHT_BLUE_ACCENT_3": "#00b0ff",
 "LIGHT_BLUE_ACCENT_1": "#80d8ff",
 "RED": "#F44336",
 "GREEN_LIGHT_3": "#A5D6A7",
 "GREEN_LIGHT_2": "#81C784",
 "GREEN_LIGHT_1": "#66BB6A",
 "GREEN_ACCENT_2": "#69F0AE",
 "GREEN_ACCENT_4": "#00C853",
 "GREEN_LIGHT_5": "#E8F5E9",
 "GREEN_LIGHT_4": "#C8E6C9",
 "CYAN_ACCENT_1": "#84ffff",
 "LIGHT_GREEN": "#8bc34a",
 "ORANGE_ACCENT_1": "#ffd180",
 "ORANGE": "#ff9800",
 "INDIGO_ACCENT_1": "#8c9eff",
 "BROWN_LIGHT_4": "#d7ccc8",
 "BROWN_LIGHT_5": "#efebe9",
 "BROWN_LIGHT_2": "#a1887f",
 "ORANGE_ACCENT_3": "#ff9100",
 "CYAN_ACCENT_3": "#00e5ff",
 "LIME_ACCENT_4": "#aeea00",
 "ORANGE_ACCENT_2": "#ffab40",
 "RED_ACCENT_1": "#FF8A80",
 "LIME_DARK_2": "#afb42b",
 "PURPLE_DARK_2": "#7b1fa2",
 "PURPLE_DARK_3": "#6a1b9a",
 "PURPLE_DARK_1": "#8e24aa",
 "PURPLE_DARK_4": "#4a148c",
 "ORANGE_ACCENT_4": "#ff6d00",
 "YELLOW": "#ffeb3b",
 "DEEP_ORANGE_LIGHT_3": "#ffab91",
 "LIME_LIGHT_1": "#d4e157",
 "LIME_LIGHT_2": "#dce775",
 "LIME_LIGHT_3": "#e6ee9c",
 "LIME_LIGHT_4": "#f0f4c3",
 "LIME_LIGHT_5": "#f9fbe7",
 "DEEP_ORANGE_LIGHT_5": "#fbe9e7",
 "AMBER_LIGHT_2": "#ffd54f",
 "BLUE": "#2196F3",
 "LIGHT_GREEN_LIGHT_1": "#9ccc65",
 "AMBER_LIGHT_1": "#ffca28",
 "LIME_DARK_4": "#827717",
 "BROWN_LIGHT_3": "#bcaaa4",
 "DEEP_ORANGE_ACCENT_4": "#dd2c00",
 "DEEP_ORANGE_DARK_3": "#d84315",
 "DEEP_ORANGE_ACCENT_1": "#ff9e80",
 "DEEP_ORANGE_ACCENT_3": "#ff3d00",
 "DEEP_ORANGE_ACCENT_2": "#ff6e40",
 "BLACK": "#000000",
 "BROWN_LIGHT_1": "#8d6e63",
 "BLUE_GREY_DARK_3": "#37474f",
 "GREEN_DARK_3": "#2E7D32",
 "ORANGE_LIGHT_5": "#fff3e0",
 "DEEP_PURPLE_ACCENT_4": "#6200ea",
 "LIGHT_GREEN_ACCENT_2": "#b2ff59",
 "DEEP_PURPLE_ACCENT_1": "#b388ff",
 "DEEP_PURPLE_ACCENT_3": "#651fff",
 "DEEP_PURPLE_ACCENT_2": "#7c4dff",
 "GREEN": "#4CAF50",
 "LIGHT_BLUE_LIGHT_2": "#4fc3f7",
 "LIGHT_BLUE_LIGHT_3": "#81d4fa",
 "ORANGE_LIGHT_1": "#ffa726",
 "LIGHT_BLUE_LIGHT_1": "#29b6f6",
 "LIGHT_BLUE_LIGHT_4": "#b3e5fc",
 "LIGHT_BLUE_LIGHT_5": "#e1f5fe",
 "PURPLE": "#9c27b0",
 "LIGHT_GREEN_LIGHT_2": "#aed581",
 "DEEP_ORANGE_DARK_1": "#f4511e",
 "BLUE_GREY_LIGHT_1": "#78909c",
 "GREY_DARK_2": "#616161",
 "LIME_DARK_3": "#9e9d24",
 "TEAL": "#009688",
 "DEEP_PURPLE_DARK_2": "#512da8",
 "DEEP_PURPLE_DARK_3": "#4527a0",
 "DEEP_PURPLE_DARK_1": "#5e35b1",
 "CYAN": "#00bcd4",
 "GREEN_DARK_4": "#1B5E20",
 "DEEP_PURPLE_DARK_4": "#311b92",
 "TEAL_LIGHT_1": "#26a69a",
 "ORANGE_LIGHT_3": "#ffcc80",
 "PINK_DARK_4": "#880e4f",
 "TEAL_LIGHT_2": "#4db6ac",
 "PINK_DARK_2": "#c2185b",
 "PINK_DARK_3": "#ad1457",
 "PINK_DARK_1": "#d81b60",
 "YELLOW_ACCENT_4": "#ffd600",
 "YELLOW_ACCENT_3": "#ffea00",
 "YELLOW_ACCENT_2": "#ffff00",
 "YELLOW_ACCENT_1": "#ffff8d",
 "AMBER": "#ffc107",
 "WHITE": "#FFFFFF",
 "PINK": "#e91e63",
 "AMBER_LIGHT_5": "#fff8e1",
 "AMBER_LIGHT_4": "#ffecb3",
 "AMBER_LIGHT_3": "#ffe082",
 "LIME_ACCENT_1": "#f4ff81",
 "LIME_ACCENT_2": "#eeff41",
 "LIME_ACCENT_3": "#c6ff00",
 "AMBER_ACCENT_4": "#ffab00",
 "ORANGE_LIGHT_4": "#ffe0b2",
 "AMBER_ACCENT_1": "#ffe57f",
 "AMBER_ACCENT_3": "#ffc400",
 "AMBER_ACCENT_2": "#ffd740",
 "PURPLE_LIGHT_3": "#ce93d8",
 "PURPLE_LIGHT_2": "#ba68c8",
 "PURPLE_LIGHT_1": "#ab47bc",
 "LIGHT_GREEN_LIGHT_3": "#c5e1a5",
 "LIGHT_GREEN_LIGHT_4": "#dcedc8",
 "LIGHT_GREEN_LIGHT_5": "#f1f8e9",
 "PURPLE_LIGHT_5": "#f3e5f5",
 "PURPLE_LIGHT_4": "#e1bee7",
 "BLUE_LIGHT_5": "#E3F2FD",
 "BLUE_LIGHT_4": "#BBDEFB",
 "BLUE_LIGHT_3": "#90CAF9",
 "BLUE_LIGHT_2": "#64B5F6",
 "BLUE_LIGHT_1": "#42A5F5",
 "BLUE_GREY": "#607d8b",
 "BLACK": "#000000",
 "WHITE": "#ffffff"
}



/*
			+ Get Random Color
				- mask:
			  	- Values:
							- For white text: White
							- For black text: Black
*/
color.GetRandomColor = function( mask ) { 
	var size, msk, msksize, num, numsk, randclr, randmsk, find;
	do {
	size = color.keys.length-3;
	msk = color["mask"+(mask?"_"+mask:"")];
	msksize = msk.length;
	num = Math.floor(Math.random()*size);
	numsk = Math.floor(Math.random()*msksize);
	randclr = color.keys[num]; 
	randmsk = msk[numsk];
	find = color[randclr+(randmsk?"_"+randmsk:"")];
	} while( !find );
	return find;
};


/*
			+Color Picker:
			- title (String): Title
			- cb (Function): Callback
			- opt (String): Options
*/
color.ShowColorPicker = function( title, cb, opt )
{
  md_color_callback = cb;
  var dlg = app._281( title||"Colors", opt );
  dlg.SetBackColor( "#FAFAFA" );
  var laydlg = app._253( "Linear", "Horizontal,Left" );
  laydlg.SetPadding( 0.01, 0.01, 0.01, 0.01 );
  dlg.AddLayout( laydlg );

  var grid = _GridLayout( null, null, 5 );
	
	for( var i in color.keys ) {
	var ck = color.keys[i];
	var clr = color[ck];
	
	if( ck == "TRANS" || ck == "WHITE" || ck == "BLACK" ) continue;
	var fab = _FAButton( "", clr );
	fab.SetOnTouch( md_ListColors );
	fab.color = ck;
	fab.opt = opt;
	grid.AddChild( fab );
	};
	
	laydlg.AddChild( grid );
  
  dlg.Show();
}

function md_ListColors()
{
	var dlg = app._281( this.color.replace("_"," "), this.opt );
	dlg.SetBackColor( "#FAFAFA" );
  var laydlg = app._253( "Linear", "Horizontal,Left" );
  laydlg.SetPadding( 0.01, 0.01, 0.01, 0.01 );
  dlg.AddLayout( laydlg );

  var grid = _GridLayout( null, null, 5, "Center,Left" );
	
	var getclrs = Object.keys(color).toString();
  
  var match = getclrs.match( RegExp("\\b"+this.color+"(?:_?[a-z,A-Z,0-9]+?_\\d?)?\\b","gm") ).sort();
	
	for( var i in match ) {
	  var clr = color[match[i]];
	  var fab = _FAButton( "", clr );
	  fab.color = clr;
	  fab.name = match[i];
	  fab.SetOnTouch( function() { dlg.Dismiss(); if( md_color_callback ) md_color_callback( this.color, this.name );  } );
	  
	  grid.AddChild( fab );
  };
  
  laydlg.AddChild( grid );
  
  dlg.Show();
}

function _GridLayout( w, h, rc, met )
{
	var laym = app._253( "Linear", met||"VCenter" );
	laym.GetType = function() { return "GridLayout"; };
	laym.SetSize( w, h );
	laym.row = rc||1;
	laym.childCount = 0;
	laym.parents = [];
	laym.childs = [];
	laym.index = 0;
	laym.Add = laym.AddChild;
	
	laym.rowLayout = app._253( "Linear", "Horizontal" );
	laym.Add( laym.rowLayout );
	
	laym.SetRowCount = function( cnt ) { laym.row = cnt; };
	laym.RemoveAll = function() {
	  //md_isdebug = app._102();
	  //if( md_isdebug ) app._101( false );
		for( var i in laym.parents ) {
			var parent = laym.parents[i];
			laym.RemoveChild( parent );
			}
			laym.parents = laym.childs = [];
			laym.index = 0;
			//if( md_isdebug ) app._101( true );
	};
	laym.AddChild = function( child ) { 
	  
		if( laym.childCount%laym.row == 0 ) { 
			laym.rowLayout = app._253( "Linear", "Horizontal" ); 
			laym.Add( laym.rowLayout ); 
		}
		laym.childs.push( child );
		laym.parents.push( laym.rowLayout );
		child.index = laym.index++;
		laym.rowLayout.AddChild( child ); 
		laym.childCount++; 
};
	
	return laym;
}

function _FAButton( icn, thm, size )
{
	var btn = app._255( icn?"[fa-"+icn+"]":"", _or(0.1,0.07)/_asp, _or(0.1,0.07), "custom,fontawesome" ); 
	btn.SetStyle( thm, thm, 100, "", 0, 0 ); 
	btn.SetTextSize( size||35, "dip" );
	btn.SetTextColor( "White" ); 
	return btn;
}